/* valaccodecompiler.c generated by valac, the Vala compiler
 * generated from valaccodecompiler.vala, do not modify */

/* valaccodecompiler.vala
 *
 * Copyright (C) 2007-2009  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>


#define VALA_TYPE_CCODE_COMPILER (vala_ccode_compiler_get_type ())
#define VALA_CCODE_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_CCODE_COMPILER, ValaCCodeCompiler))
#define VALA_CCODE_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_CCODE_COMPILER, ValaCCodeCompilerClass))
#define VALA_IS_CCODE_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_CCODE_COMPILER))
#define VALA_IS_CCODE_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_CCODE_COMPILER))
#define VALA_CCODE_COMPILER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_CCODE_COMPILER, ValaCCodeCompilerClass))

typedef struct _ValaCCodeCompiler ValaCCodeCompiler;
typedef struct _ValaCCodeCompilerClass ValaCCodeCompilerClass;
typedef struct _ValaCCodeCompilerPrivate ValaCCodeCompilerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ValaParamSpecCCodeCompiler ValaParamSpecCCodeCompiler;

struct _ValaCCodeCompiler {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValaCCodeCompilerPrivate * priv;
};

struct _ValaCCodeCompilerClass {
	GTypeClass parent_class;
	void (*finalize) (ValaCCodeCompiler *self);
};

struct _ValaParamSpecCCodeCompiler {
	GParamSpec parent_instance;
};


static gpointer vala_ccode_compiler_parent_class = NULL;

gpointer vala_ccode_compiler_ref (gpointer instance);
void vala_ccode_compiler_unref (gpointer instance);
GParamSpec* vala_param_spec_ccode_compiler (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void vala_value_set_ccode_compiler (GValue* value,
                                    gpointer v_object);
void vala_value_take_ccode_compiler (GValue* value,
                                     gpointer v_object);
gpointer vala_value_get_ccode_compiler (const GValue* value);
GType vala_ccode_compiler_get_type (void) G_GNUC_CONST;
ValaCCodeCompiler* vala_ccode_compiler_new (void);
ValaCCodeCompiler* vala_ccode_compiler_construct (GType object_type);
void vala_ccode_compiler_compile (ValaCCodeCompiler* self,
                                  ValaCodeContext* context,
                                  const gchar* cc_command,
                                  gchar** cc_options,
                                  int cc_options_length1);
static void vala_ccode_compiler_finalize (ValaCCodeCompiler * obj);


ValaCCodeCompiler*
vala_ccode_compiler_construct (GType object_type)
{
	ValaCCodeCompiler* self = NULL;
	self = (ValaCCodeCompiler*) g_type_create_instance (object_type);
	return self;
}


ValaCCodeCompiler*
vala_ccode_compiler_new (void)
{
	return vala_ccode_compiler_construct (VALA_TYPE_CCODE_COMPILER);
}


/**
 * Compile generated C code to object code and optionally link object
 * files.
 *
 * @param context a code context
 */
static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


void
vala_ccode_compiler_compile (ValaCCodeCompiler* self,
                             ValaCodeContext* context,
                             const gchar* cc_command,
                             gchar** cc_options,
                             int cc_options_length1)
{
	gchar* pc = NULL;
	gchar* _tmp0_;
	ValaProfile _tmp1_;
	ValaProfile _tmp2_;
	gchar* pkgflags = NULL;
	const gchar* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gchar* cmdline = NULL;
	gchar* _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	ValaList* source_files = NULL;
	ValaList* _tmp63_;
	ValaList* _tmp64_;
	ValaList* c_source_files = NULL;
	ValaList* _tmp88_;
	ValaList* _tmp89_;
	const gchar* _tmp108_;
	const gchar* _tmp109_;
	gchar* _tmp110_;
	gchar* _tmp111_;
	gchar* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	gboolean _tmp123_;
	gboolean _tmp124_;
	gboolean _tmp133_;
	gboolean _tmp134_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = g_strdup ("");
	pc = _tmp0_;
	_tmp1_ = vala_code_context_get_profile (context);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == VALA_PROFILE_GOBJECT) {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = pc;
		_tmp4_ = g_strconcat (_tmp3_, " gobject-2.0", NULL);
		_g_free0 (pc);
		pc = _tmp4_;
	}
	{
		ValaList* _pkg_list = NULL;
		ValaList* _tmp5_;
		ValaList* _tmp6_;
		gint _pkg_size = 0;
		ValaList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _pkg_index = 0;
		_tmp5_ = vala_code_context_get_packages (context);
		_tmp6_ = _vala_iterable_ref0 (_tmp5_);
		_pkg_list = _tmp6_;
		_tmp7_ = _pkg_list;
		_tmp8_ = vala_collection_get_size ((ValaCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_pkg_size = _tmp9_;
		_pkg_index = -1;
		while (TRUE) {
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gchar* pkg = NULL;
			ValaList* _tmp13_;
			gint _tmp14_;
			gpointer _tmp15_;
			const gchar* _tmp16_;
			_tmp10_ = _pkg_index;
			_pkg_index = _tmp10_ + 1;
			_tmp11_ = _pkg_index;
			_tmp12_ = _pkg_size;
			if (!(_tmp11_ < _tmp12_)) {
				break;
			}
			_tmp13_ = _pkg_list;
			_tmp14_ = _pkg_index;
			_tmp15_ = vala_list_get (_tmp13_, _tmp14_);
			pkg = (gchar*) _tmp15_;
			_tmp16_ = pkg;
			if (vala_code_context_pkg_config_exists (context, _tmp16_)) {
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				_tmp17_ = pc;
				_tmp18_ = pkg;
				_tmp19_ = g_strconcat (" ", _tmp18_, NULL);
				_tmp20_ = _tmp19_;
				_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
				_g_free0 (pc);
				pc = _tmp21_;
				_g_free0 (_tmp20_);
			}
			_g_free0 (pkg);
		}
		_vala_iterable_unref0 (_pkg_list);
	}
	_tmp22_ = pc;
	_tmp23_ = strlen (_tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_ > 0) {
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		_tmp25_ = pc;
		_tmp26_ = vala_code_context_pkg_config_compile_flags (context, _tmp25_);
		_g_free0 (pkgflags);
		pkgflags = _tmp26_;
		_tmp27_ = pkgflags;
		if (_tmp27_ == NULL) {
			_g_free0 (pkgflags);
			_g_free0 (pc);
			return;
		}
	} else {
		gchar* _tmp28_;
		_tmp28_ = g_strdup ("");
		_g_free0 (pkgflags);
		pkgflags = _tmp28_;
	}
	if (cc_command == NULL) {
		cc_command = "cc";
	}
	_tmp29_ = g_strdup (cc_command);
	cmdline = _tmp29_;
	_tmp30_ = vala_code_context_get_debug (context);
	_tmp31_ = _tmp30_;
	if (_tmp31_) {
		const gchar* _tmp32_;
		gchar* _tmp33_;
		_tmp32_ = cmdline;
		_tmp33_ = g_strconcat (_tmp32_, " -g", NULL);
		_g_free0 (cmdline);
		cmdline = _tmp33_;
	}
	_tmp34_ = vala_code_context_get_compile_only (context);
	_tmp35_ = _tmp34_;
	if (_tmp35_) {
		const gchar* _tmp36_;
		gchar* _tmp37_;
		_tmp36_ = cmdline;
		_tmp37_ = g_strconcat (_tmp36_, " -c", NULL);
		_g_free0 (cmdline);
		cmdline = _tmp37_;
	} else {
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		_tmp38_ = vala_code_context_get_output (context);
		_tmp39_ = _tmp38_;
		if (_tmp39_ != NULL) {
			gchar* output = NULL;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			gboolean _tmp43_ = FALSE;
			gboolean _tmp44_ = FALSE;
			const gchar* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp56_;
			const gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
			_tmp40_ = vala_code_context_get_output (context);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_strdup (_tmp41_);
			output = _tmp42_;
			_tmp45_ = vala_code_context_get_directory (context);
			_tmp46_ = _tmp45_;
			if (_tmp46_ != NULL) {
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				_tmp47_ = vala_code_context_get_directory (context);
				_tmp48_ = _tmp47_;
				_tmp44_ = g_strcmp0 (_tmp48_, "") != 0;
			} else {
				_tmp44_ = FALSE;
			}
			if (_tmp44_) {
				const gchar* _tmp49_;
				const gchar* _tmp50_;
				_tmp49_ = vala_code_context_get_output (context);
				_tmp50_ = _tmp49_;
				_tmp43_ = !g_path_is_absolute (_tmp50_);
			} else {
				_tmp43_ = FALSE;
			}
			if (_tmp43_) {
				const gchar* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				_tmp51_ = vala_code_context_get_directory (context);
				_tmp52_ = _tmp51_;
				_tmp53_ = vala_code_context_get_output (context);
				_tmp54_ = _tmp53_;
				_tmp55_ = g_strdup_printf ("%s%c%s", _tmp52_, (gint) G_DIR_SEPARATOR, _tmp54_);
				_g_free0 (output);
				output = _tmp55_;
			}
			_tmp56_ = cmdline;
			_tmp57_ = output;
			_tmp58_ = g_shell_quote (_tmp57_);
			_tmp59_ = _tmp58_;
			_tmp60_ = g_strconcat (" -o ", _tmp59_, NULL);
			_tmp61_ = _tmp60_;
			_tmp62_ = g_strconcat (_tmp56_, _tmp61_, NULL);
			_g_free0 (cmdline);
			cmdline = _tmp62_;
			_g_free0 (_tmp61_);
			_g_free0 (_tmp59_);
			_g_free0 (output);
		}
	}
	_tmp63_ = vala_code_context_get_source_files (context);
	_tmp64_ = _vala_iterable_ref0 (_tmp63_);
	source_files = _tmp64_;
	{
		ValaList* _file_list = NULL;
		ValaList* _tmp65_;
		ValaList* _tmp66_;
		gint _file_size = 0;
		ValaList* _tmp67_;
		gint _tmp68_;
		gint _tmp69_;
		gint _file_index = 0;
		_tmp65_ = source_files;
		_tmp66_ = _vala_iterable_ref0 (_tmp65_);
		_file_list = _tmp66_;
		_tmp67_ = _file_list;
		_tmp68_ = vala_collection_get_size ((ValaCollection*) _tmp67_);
		_tmp69_ = _tmp68_;
		_file_size = _tmp69_;
		_file_index = -1;
		while (TRUE) {
			gint _tmp70_;
			gint _tmp71_;
			gint _tmp72_;
			ValaSourceFile* file = NULL;
			ValaList* _tmp73_;
			gint _tmp74_;
			gpointer _tmp75_;
			ValaSourceFile* _tmp76_;
			ValaSourceFileType _tmp77_;
			ValaSourceFileType _tmp78_;
			_tmp70_ = _file_index;
			_file_index = _tmp70_ + 1;
			_tmp71_ = _file_index;
			_tmp72_ = _file_size;
			if (!(_tmp71_ < _tmp72_)) {
				break;
			}
			_tmp73_ = _file_list;
			_tmp74_ = _file_index;
			_tmp75_ = vala_list_get (_tmp73_, _tmp74_);
			file = (ValaSourceFile*) _tmp75_;
			_tmp76_ = file;
			_tmp77_ = vala_source_file_get_file_type (_tmp76_);
			_tmp78_ = _tmp77_;
			if (_tmp78_ == VALA_SOURCE_FILE_TYPE_SOURCE) {
				const gchar* _tmp79_;
				ValaSourceFile* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				gchar* _tmp86_;
				gchar* _tmp87_;
				_tmp79_ = cmdline;
				_tmp80_ = file;
				_tmp81_ = vala_source_file_get_csource_filename (_tmp80_);
				_tmp82_ = _tmp81_;
				_tmp83_ = g_shell_quote (_tmp82_);
				_tmp84_ = _tmp83_;
				_tmp85_ = g_strconcat (" ", _tmp84_, NULL);
				_tmp86_ = _tmp85_;
				_tmp87_ = g_strconcat (_tmp79_, _tmp86_, NULL);
				_g_free0 (cmdline);
				cmdline = _tmp87_;
				_g_free0 (_tmp86_);
				_g_free0 (_tmp84_);
				_g_free0 (_tmp82_);
			}
			_vala_source_file_unref0 (file);
		}
		_vala_iterable_unref0 (_file_list);
	}
	_tmp88_ = vala_code_context_get_c_source_files (context);
	_tmp89_ = _vala_iterable_ref0 (_tmp88_);
	c_source_files = _tmp89_;
	{
		ValaList* _file_list = NULL;
		ValaList* _tmp90_;
		ValaList* _tmp91_;
		gint _file_size = 0;
		ValaList* _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		gint _file_index = 0;
		_tmp90_ = c_source_files;
		_tmp91_ = _vala_iterable_ref0 (_tmp90_);
		_file_list = _tmp91_;
		_tmp92_ = _file_list;
		_tmp93_ = vala_collection_get_size ((ValaCollection*) _tmp92_);
		_tmp94_ = _tmp93_;
		_file_size = _tmp94_;
		_file_index = -1;
		while (TRUE) {
			gint _tmp95_;
			gint _tmp96_;
			gint _tmp97_;
			gchar* file = NULL;
			ValaList* _tmp98_;
			gint _tmp99_;
			gpointer _tmp100_;
			const gchar* _tmp101_;
			const gchar* _tmp102_;
			gchar* _tmp103_;
			gchar* _tmp104_;
			gchar* _tmp105_;
			gchar* _tmp106_;
			gchar* _tmp107_;
			_tmp95_ = _file_index;
			_file_index = _tmp95_ + 1;
			_tmp96_ = _file_index;
			_tmp97_ = _file_size;
			if (!(_tmp96_ < _tmp97_)) {
				break;
			}
			_tmp98_ = _file_list;
			_tmp99_ = _file_index;
			_tmp100_ = vala_list_get (_tmp98_, _tmp99_);
			file = (gchar*) _tmp100_;
			_tmp101_ = cmdline;
			_tmp102_ = file;
			_tmp103_ = g_shell_quote (_tmp102_);
			_tmp104_ = _tmp103_;
			_tmp105_ = g_strconcat (" ", _tmp104_, NULL);
			_tmp106_ = _tmp105_;
			_tmp107_ = g_strconcat (_tmp101_, _tmp106_, NULL);
			_g_free0 (cmdline);
			cmdline = _tmp107_;
			_g_free0 (_tmp106_);
			_g_free0 (_tmp104_);
			_g_free0 (file);
		}
		_vala_iterable_unref0 (_file_list);
	}
	_tmp108_ = cmdline;
	_tmp109_ = pkgflags;
	_tmp110_ = string_strip (_tmp109_);
	_tmp111_ = _tmp110_;
	_tmp112_ = g_strconcat (" ", _tmp111_, NULL);
	_tmp113_ = _tmp112_;
	_tmp114_ = g_strconcat (_tmp108_, _tmp113_, NULL);
	_g_free0 (cmdline);
	cmdline = _tmp114_;
	_g_free0 (_tmp113_);
	_g_free0 (_tmp111_);
	{
		gchar** cc_option_collection = NULL;
		gint cc_option_collection_length1 = 0;
		gint _cc_option_collection_size_ = 0;
		gint cc_option_it = 0;
		cc_option_collection = cc_options;
		cc_option_collection_length1 = cc_options_length1;
		for (cc_option_it = 0; cc_option_it < cc_option_collection_length1; cc_option_it = cc_option_it + 1) {
			gchar* _tmp115_;
			gchar* cc_option = NULL;
			_tmp115_ = g_strdup (cc_option_collection[cc_option_it]);
			cc_option = _tmp115_;
			{
				const gchar* _tmp116_;
				const gchar* _tmp117_;
				gchar* _tmp118_;
				gchar* _tmp119_;
				gchar* _tmp120_;
				gchar* _tmp121_;
				gchar* _tmp122_;
				_tmp116_ = cmdline;
				_tmp117_ = cc_option;
				_tmp118_ = g_shell_quote (_tmp117_);
				_tmp119_ = _tmp118_;
				_tmp120_ = g_strconcat (" ", _tmp119_, NULL);
				_tmp121_ = _tmp120_;
				_tmp122_ = g_strconcat (_tmp116_, _tmp121_, NULL);
				_g_free0 (cmdline);
				cmdline = _tmp122_;
				_g_free0 (_tmp121_);
				_g_free0 (_tmp119_);
				_g_free0 (cc_option);
			}
		}
	}
	_tmp123_ = vala_code_context_get_verbose_mode (context);
	_tmp124_ = _tmp123_;
	if (_tmp124_) {
		FILE* _tmp125_;
		const gchar* _tmp126_;
		_tmp125_ = stdout;
		_tmp126_ = cmdline;
		fprintf (_tmp125_, "%s\n", _tmp126_);
	}
	{
		gint exit_status = 0;
		const gchar* _tmp127_;
		gint _tmp128_ = 0;
		gint _tmp129_;
		_tmp127_ = cmdline;
		g_spawn_command_line_sync (_tmp127_, NULL, NULL, &_tmp128_, &_inner_error0_);
		exit_status = _tmp128_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch3_g_spawn_error;
			}
			_vala_iterable_unref0 (c_source_files);
			_vala_iterable_unref0 (source_files);
			_g_free0 (cmdline);
			_g_free0 (pkgflags);
			_g_free0 (pc);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp129_ = exit_status;
		if (_tmp129_ != 0) {
			gint _tmp130_;
			_tmp130_ = exit_status;
			vala_report_error (NULL, "cc exited with status %d", _tmp130_);
		}
	}
	goto __finally3;
	__catch3_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp131_;
		const gchar* _tmp132_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp131_ = e;
		_tmp132_ = _tmp131_->message;
		vala_report_error (NULL, "%s", _tmp132_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_iterable_unref0 (c_source_files);
		_vala_iterable_unref0 (source_files);
		_g_free0 (cmdline);
		_g_free0 (pkgflags);
		_g_free0 (pc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp133_ = vala_code_context_get_save_csources (context);
	_tmp134_ = _tmp133_;
	if (!_tmp134_) {
		{
			ValaList* _file_list = NULL;
			ValaList* _tmp135_;
			ValaList* _tmp136_;
			gint _file_size = 0;
			ValaList* _tmp137_;
			gint _tmp138_;
			gint _tmp139_;
			gint _file_index = 0;
			_tmp135_ = source_files;
			_tmp136_ = _vala_iterable_ref0 (_tmp135_);
			_file_list = _tmp136_;
			_tmp137_ = _file_list;
			_tmp138_ = vala_collection_get_size ((ValaCollection*) _tmp137_);
			_tmp139_ = _tmp138_;
			_file_size = _tmp139_;
			_file_index = -1;
			while (TRUE) {
				gint _tmp140_;
				gint _tmp141_;
				gint _tmp142_;
				ValaSourceFile* file = NULL;
				ValaList* _tmp143_;
				gint _tmp144_;
				gpointer _tmp145_;
				ValaSourceFile* _tmp146_;
				ValaSourceFileType _tmp147_;
				ValaSourceFileType _tmp148_;
				_tmp140_ = _file_index;
				_file_index = _tmp140_ + 1;
				_tmp141_ = _file_index;
				_tmp142_ = _file_size;
				if (!(_tmp141_ < _tmp142_)) {
					break;
				}
				_tmp143_ = _file_list;
				_tmp144_ = _file_index;
				_tmp145_ = vala_list_get (_tmp143_, _tmp144_);
				file = (ValaSourceFile*) _tmp145_;
				_tmp146_ = file;
				_tmp147_ = vala_source_file_get_file_type (_tmp146_);
				_tmp148_ = _tmp147_;
				if (_tmp148_ == VALA_SOURCE_FILE_TYPE_SOURCE) {
					ValaSourceFile* _tmp149_;
					gchar* _tmp150_;
					gchar* _tmp151_;
					_tmp149_ = file;
					_tmp150_ = vala_source_file_get_csource_filename (_tmp149_);
					_tmp151_ = _tmp150_;
					g_unlink (_tmp151_);
					_g_free0 (_tmp151_);
				}
				_vala_source_file_unref0 (file);
			}
			_vala_iterable_unref0 (_file_list);
		}
	}
	_vala_iterable_unref0 (c_source_files);
	_vala_iterable_unref0 (source_files);
	_g_free0 (cmdline);
	_g_free0 (pkgflags);
	_g_free0 (pc);
}


static void
vala_value_ccode_compiler_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
vala_value_ccode_compiler_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		vala_ccode_compiler_unref (value->data[0].v_pointer);
	}
}


static void
vala_value_ccode_compiler_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = vala_ccode_compiler_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
vala_value_ccode_compiler_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
vala_value_ccode_compiler_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		ValaCCodeCompiler * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = vala_ccode_compiler_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
vala_value_ccode_compiler_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	ValaCCodeCompiler ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = vala_ccode_compiler_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
vala_param_spec_ccode_compiler (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ValaParamSpecCCodeCompiler* spec;
	g_return_val_if_fail (g_type_is_a (object_type, VALA_TYPE_CCODE_COMPILER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
vala_value_get_ccode_compiler (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_COMPILER), NULL);
	return value->data[0].v_pointer;
}


void
vala_value_set_ccode_compiler (GValue* value,
                               gpointer v_object)
{
	ValaCCodeCompiler * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_COMPILER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALA_TYPE_CCODE_COMPILER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		vala_ccode_compiler_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		vala_ccode_compiler_unref (old);
	}
}


void
vala_value_take_ccode_compiler (GValue* value,
                                gpointer v_object)
{
	ValaCCodeCompiler * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_COMPILER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALA_TYPE_CCODE_COMPILER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		vala_ccode_compiler_unref (old);
	}
}


static void
vala_ccode_compiler_class_init (ValaCCodeCompilerClass * klass)
{
	vala_ccode_compiler_parent_class = g_type_class_peek_parent (klass);
	((ValaCCodeCompilerClass *) klass)->finalize = vala_ccode_compiler_finalize;
}


static void
vala_ccode_compiler_instance_init (ValaCCodeCompiler * self)
{
	self->ref_count = 1;
}


static void
vala_ccode_compiler_finalize (ValaCCodeCompiler * obj)
{
	ValaCCodeCompiler * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_COMPILER, ValaCCodeCompiler);
	g_signal_handlers_destroy (self);
}


/**
 * Interface to the C compiler.
 */
GType
vala_ccode_compiler_get_type (void)
{
	static volatile gsize vala_ccode_compiler_type_id__volatile = 0;
	if (g_once_init_enter (&vala_ccode_compiler_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { vala_value_ccode_compiler_init, vala_value_ccode_compiler_free_value, vala_value_ccode_compiler_copy_value, vala_value_ccode_compiler_peek_pointer, "p", vala_value_ccode_compiler_collect_value, "p", vala_value_ccode_compiler_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeCompilerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_compiler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeCompiler), 0, (GInstanceInitFunc) vala_ccode_compiler_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType vala_ccode_compiler_type_id;
		vala_ccode_compiler_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ValaCCodeCompiler", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&vala_ccode_compiler_type_id__volatile, vala_ccode_compiler_type_id);
	}
	return vala_ccode_compiler_type_id__volatile;
}


gpointer
vala_ccode_compiler_ref (gpointer instance)
{
	ValaCCodeCompiler * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
vala_ccode_compiler_unref (gpointer instance)
{
	ValaCCodeCompiler * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VALA_CCODE_COMPILER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



